// MIRSAK パトロール走行
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "mirsak.h"
#include "patrol_sequence.h"
#include "hardware.h"
#include "direction.h"
#include "run_ctrl.h"
#include "number.h"
#include "io.h"

//enum run_mode run_mode;

//static void get_patrol_data(int i, char *style, int *value)
static void get_patrol_data(int i, int *style, int *value)
{
	struct patrol_data *data;
	data = pt_data;
	*style=(data+i)->style;
	*value=(data+i)->value;
}


//正体補正をするシーケンス番号
static int dir_number[20] ={6,12};

//数字認識する場所のシーケンス番号
static int num_number[20] ={6,12};

void mirsak_patrol(){

	float default_speed = 95.0; //直進速度[cm/sec] 
	float default_speed_rot = 55.0; //70.0; //回転速度 [deg/sec]
	int max_sequence_num=12; //終了までのシーケンス数
	float speed;
	int sequence_num=1;
	int dcount =0;
	int ncount =0;
	//int left_num, right_num;
	int face_distance = 40; //正体補正する距離
	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）
	int num_distance = face_distance - CAM_USS_DIF ; 
	int numbers[2];

	int style=0;
	int value=0;
	int ret_val;

	number_set_nums(1); //ボード上の数字の数を2にセット

  char muki;
  char io[12];

  printf("press r or l\n");
  scanf("%c",&muki);

	while(1){

    if(muki=='l' && sequence_num==1){
      sequence_num = 7;
    }else if(muki=='r' && sequence_num==7){
      sequence_num = 13;
    }

		get_patrol_data(sequence_num-1, &style, &value); 
		printf("sequence_num=%d     style=%d      value=%d   \n", sequence_num, style, value);
		if(style==STRAIGHT){
			if(value>0){
				speed=default_speed;
//      if(sequence_num == 4) speed = 50.0;
//      if(sequence_num == 10) speed = 50.0;
        if(sequence_num==5) speed = 8.0;//55.0;
        if(sequence_num==11) speed = 8.0;//55.0;
			}else{
				speed=-default_speed;
			}
		}
		if(style==ROTATE){
			if(value>0){
				speed=default_speed_rot;
			}else{
				speed=-default_speed_rot;
			}
		}

		run_ctrl_set(style, speed); 
		run_ctrl_set_dist((float)value);
		run_ctrl_create();

		// endflag が 1 になるまで loop する
		while(1){
      
      if(sequence_num==2 || sequence_num==8){ 
       //  usleep(1000*1000);
         break;
      }

      io_get(io);
      if(io[1]=='1' && sequence_num==5) break;
      if(io[1]=='1' && sequence_num==11) break;

			if(run_ctrl_get_endflag()==1) break;
			 usleep(20000);
		}
		run_ctrl_cancel();

		//指定したシーケンスで正体補正する
		//if(dir_number[dcount]==sequence_num){
    if(sequence_num == 6 || sequence_num == 12){
      ret_val=direction_correct(face_distance);
			dcount++;
		}
		//指定したシーケンスで数字認識する
		//if(num_number[ncount]==sequence_num){
		if(sequence_num == 6 || sequence_num == 12){
      ret_val = number_detect(num_distance); //数字認識
        		number_get(numbers);
                	printf("左数字=%d、右数字=%d\n",numbers[0],numbers[1]);
			ncount++;
		}

		sequence_num++;
		//終了シーケンス数になったら while を抜け、終了
		if(sequence_num > max_sequence_num) break;

		usleep(10*10);

	}

	run_ctrl_stop();
	usleep(100*1000);

}
