/*
与えたPWM値に対するタイヤ回転速度を確認するプログラム
created 2014/7/10
*/

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "mirsak.h"
#include "encoder.h"
#include "motor.h"

//static pthread_t task_id;
//static pthread_t task_id;
//static int pwm_duty_r, pwm_duty_l;

//unsigned char m_data[2];
//static int fd_motor;
//static int fd_encoder;

//static float t_coef = 2*3.1415*TIRE_R/ENC_PPS/T_ENCODER*1000/M_E_RATIO; //for STANDARD MIRS

//static void *thread_code(void *t){
void test_pwm_vel(){

	int pwm_duty_r, pwm_duty_l;

	unsigned char m_data[2];
	int fd_motor;

	FILE *fp;
	int counter=0;
	int ret_val;
	struct encoder_data encoder_data;
	float vel_l, vel_r;
	int s_val;
	float t_coef = 2*3.1415*TIRE_R/ENC_PPS/T_ENCODER*1000/M_E_RATIO; //for STANDARD MIRS

	fp=fopen("test.data","w");
	fd_motor=device_motor_get();

	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);

	if(pwm_duty_l < 0) pwm_duty_l = 128 - pwm_duty_l;
	if(pwm_duty_r < 0) pwm_duty_r = 128 - pwm_duty_r;

	encoder_create();

	printf("enc_left \t enc_right \t  enc_left_sum \t enc_right_sum\n");

	while(1){
		counter++;

		//if(counter > 200) break;
		
		//ret_val=write(fd_motor,m_data,2);

		//motor_drive(pwm_duty_l, pwm_duty_r);

		m_data[0]=pwm_duty_l;
		m_data[1]=pwm_duty_r;
		ret_val=write(fd_motor,m_data,2);

		//encoder_read(&encoder_data);
		encoder_get(&encoder_data);

		//printf("counter=%5d left=%5d  right=%5d left_sum=%5d right_sum=%5d\n",counter,encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);
		printf("left=%5d    right=%5d    left_sum=%5d    right_sum=%5d\n",encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);

		vel_l = encoder_data.left * t_coef;
                vel_r = encoder_data.right * t_coef;
		printf("vel_l=%5d[cm/s], vel_r=%5d[cm/s]\n",(int)vel_l, (int)vel_r);


		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価
		//usleep((T_CTRL_VEL -1) *1000 ); // 1ms はスケジューラの精度で遅れる
		usleep((T_TEST-1)*1000);

	}

	
	m_data[0]=0;
	m_data[1]=0;
	ret_val=write(fd_motor,m_data,2);
	//motor_drive(0,0);

	fclose(fp);
	return ;

}

/*
static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	//ret = pthread_create(&task_id, &attr, thread_code, (void *)2);
	ret = pthread_create(&task_id, &attr, thread_code, (void *)2);

	return 0;
}

void test_pwm_vel(){

	int s_val;
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);

	if(pwm_duty_l < 0) pwm_duty_l = 128 - pwm_duty_l;
	if(pwm_duty_r < 0) pwm_duty_r = 128 - pwm_duty_r;

	thread_create();
	encoder_create();

	//printf("thread_id=%d\n",(int)task_id);
	printf("thread_id=%d\n",(int)task_id);
	//pthread_join(task_id,NULL);
	pthread_join(task_id,NULL);
	printf("Program stopped\n");

}
*/


