/*
速度制御テスト	2014/7/3
速度の実数入力対応版
*/
#include <stdio.h>
#include <stdlib.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "hardware.h"
#include "encoder.h"
#include "vel_ctrl.h"
#include "distance.h"

static int MAX_LOOP=200; //最大のループ回数
static int start_count = 50;//平均速度と分散の計測を開始しし始めるループ回数

void test_vel_ctrl(){

	int s_val;
	float vel_r_ref, vel_l_ref;
	FILE *fp;
	int counter=0;
	//int ret_val;
	//struct encoder_data encoder_data;
	float left_spd, right_spd;
	struct distance_data distance_data;
	float sum_left=0, sum_right=0;
	float var_left=0, var_right=0;

	fp=fopen("test.data","w");

	printf("left speed value [cm/s]= ");
	s_val=scanf("%f",&vel_l_ref);
	printf("right speed value [cm/s]= ");
	s_val=scanf("%f",&vel_r_ref);

	encoder_create();

	//vel_ctrl_set((float)vel_l_ref, (float)vel_r_ref); 
	vel_ctrl_set(vel_l_ref, vel_r_ref); 
	vel_ctrl_create();



	//printf("enc_left \t enc_right \t  enc_left_sum \t enc_right_sum\n");


	while(1){
		counter++;

		//if(counter > 200) break;

		//encoder_get(&encoder_data);
		//printf("left=%5d    right=%5d   left_sum=%5d   right_sum=%5d\n",encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);

		vel_ctrl_get_speed(&left_spd, &right_spd);
		distance_get(&distance_data);
		if(counter > start_count){
			sum_left += left_spd;
			sum_right += right_spd;
			var_left += (left_spd - sum_left/counter)* (left_spd - sum_left/counter);
			var_right += (right_spd - sum_right/counter)* (right_spd - sum_right/counter);
		}
		printf("left_speed=%5.1f     right speed=%5.1f     dis_left=%5.1f    dis_right=%5.1f\n",left_spd, right_spd, distance_data.left, distance_data.right);
		//printf("left_speed=%5.1f     right speed=%5.1f     mean_left=%5.1f    mean_right=%5.1f\n",left_spd, right_spd, sum_left/counter, sum_right/counter);

		//int ivel, i;
		//ivel =  left_spd;
		//ivel =  right_spd;
		//for(i=0; i<=ivel; i++) printf("*");
		//printf("\n");

		usleep((T_TEST-1)*1000); // 実行周期

		if(counter > MAX_LOOP) break;

	}
	//vel_ctrl_set(0.0, 0.0); 
	int ret_val;
	ret_val = system("./motor_stop"); 

	printf("mean_left=%5.1f    mean_right=%5.1f  var_left=%5.1f var_right=%5.1f \n",sum_left/(MAX_LOOP-start_count), sum_right/(MAX_LOOP-start_count), var_left/(MAX_LOOP-start_count), var_right/(MAX_LOOP-start_count));

	fclose(fp);
	return ;

}

